package IntegrationObject;

import java.beans.*;
import java.lang.reflect.*;
import java.lang.*;
import java.util.*;
import com.ibm.HostPublisher.IntegrationObject.*;

public class Callupchain1BeanInfo extends SimpleBeanInfo
{ 
   ResourceBundle res = ResourceBundle.getBundle("com.ibm.HostPublisher.IntegrationObject.HPub_Resources",
                                                 Locale.getDefault());

   public BeanInfo[] getAdditionalBeanInfo()
   {
     try
     {
       BeanInfo hPubBi1 = Introspector.getBeanInfo(Callupchain1.class.getSuperclass());
 
       BeanInfo[] arrayOfBIs = { hPubBi1 };
       return arrayOfBIs;
     }
     catch (IntrospectionException e)
     {
       e.printStackTrace();
     }

     return null;
   }

  public PropertyDescriptor[] getPropertyDescriptors()
  { try
    { // Generated Code
      String stringPackageName =  new String("IntegrationObject");


     
      PropertyDescriptor pdNumberOfHits = new PropertyDescriptor("numberOfHits", Class.forName(stringPackageName + "." + "Callupchain1"),
                                        "getNumberOfHits",null);
      PropertyDescriptor pdLastName = new PropertyDescriptor("lastName", Class.forName(stringPackageName + "." + "Callupchain1"),
                                        "getLastName","setLastName");
     



      PropertyDescriptor pdHPubXMLProperties = new PropertyDescriptor("hPubXMLProperties",
                                                     com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                     "getHPubXMLProperties",null); 

      PropertyDescriptor pdHPubStartPoolName = new PropertyDescriptor("hPubStartPoolName",
                                                     com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                     "getHPubStartPoolName","setHPubStartPoolName"); 

      PropertyDescriptor pdHPubStartChainName = new PropertyDescriptor("hPubStartChainName",
                                                     com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                     "getHPubStartChainName", null); 

      PropertyDescriptor pdHPubEndChainName = new PropertyDescriptor("hPubEndChainName",
                                                     com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                     "getHPubEndChainName", null); 

      PropertyDescriptor pdHPubStartType = new PropertyDescriptor("hPubStartType",
                                                     com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                     "getHPubStartType", null); 

      PropertyDescriptor pdHPubEndType = new PropertyDescriptor("hPubEndType",
                                                     com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                     "getHPubEndType", null); 

      PropertyDescriptor pdHPubErrorException = new PropertyDescriptor("hPubErrorException",
                                                    com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                    "getHPubErrorException", null); 
      String hPubExceptionPropDesc = res.getString("hPubExceptionPropDesc");
      pdHPubErrorException.setShortDescription(hPubExceptionPropDesc);



      PropertyDescriptor pdHPubScreenState = new PropertyDescriptor("hPubScreenState",
                                                                    Class.forName(stringPackageName + "." + "Callupchain1"),   
                                                                    "getHPubScreenState", null); 

      PropertyDescriptor pdHPubMacroMessage = new PropertyDescriptor("hPubMacroMessage",
                                                                     Class.forName(stringPackageName + "." + "Callupchain1"), 
                                                                     "getHPubMacroMessage", null); 

      PropertyDescriptor[] arrayOfPDs = { 
                                          pdNumberOfHits,
                                          pdLastName,
                                          pdHPubXMLProperties,
                                          pdHPubStartPoolName,
                                          pdHPubStartChainName,
                                          pdHPubEndChainName,
                                          pdHPubStartType,
                                          pdHPubEndType,
                                          pdHPubErrorException,
                                          pdHPubMacroMessage,
                                          pdHPubScreenState
                                        };
      return arrayOfPDs;
    }
    catch (Exception e) 
    { System.out.println(e);
      return null;
    }
  }

  // ***** *****
  public MethodDescriptor[] getMethodDescriptors() 
  {
     try
     { 
        MethodDescriptor md1 = new MethodDescriptor(getMethod(com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, "processRequest"));
        String procReqDesc = res.getString("procReqDesc");
        md1.setShortDescription(procReqDesc);


        MethodDescriptor md2 = new MethodDescriptor(getMethod(com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, "doHPTransaction"));
        String doHPTransDesc = res.getString("doHPTransDesc");
        md2.setShortDescription(doHPTransDesc);
        
        // method for receiving event
        MethodDescriptor md3 = new MethodDescriptor(getMethod(com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, "hPubStartPerformed")); 
        String hPubStartPerfDesc = res.getString("hPubStartPerfDesc");
        md3.setShortDescription(hPubStartPerfDesc);

        MethodDescriptor[] arrayOfMDs = { md1,
                                          md2,
                                          md3
                                        }; 
        return arrayOfMDs;
     
      } 
      catch (IntrospectionException e) 
      {
        e.printStackTrace();
      }
      return null;
  }

  Method getMethod(Class cls, String methodName) throws IntrospectionException 
  { Method methods[] = cls.getMethods();

    for (int i=0; i < methods.length; i++)
    { if (methods[i].getName().equals(methodName))
      { return methods[i];
      }
    }
    throw new IntrospectionException("No method \"" + methodName);
  }

  // ***** *****
  public EventSetDescriptor[] getEventSetDescriptors()
  { try
    {  EventSetDescriptor eventHPubReqComplete = 
         new EventSetDescriptor(com.ibm.HostPublisher.IntegrationObject.HPubCommon.class,
                                "requestComplete",
                                com.ibm.HostPublisher.IntegrationObject.HPubReqCompleteListener.class,
                                "hPubReqComplete");
       
       String reqCompleteName = res.getString("reqCompleteName");
       eventHPubReqComplete.setDisplayName(reqCompleteName);
       String reqCompleteDesc = res.getString("reqCompleteDesc");
       eventHPubReqComplete.setShortDescription(reqCompleteDesc);


       EventSetDescriptor[] arrayOfESDs = {
                                           eventHPubReqComplete
                                          };

       return arrayOfESDs;
    }
    catch (IntrospectionException e) 
    { System.out.println(e);
      return null;
    }
  }

}



